if (GetLocale() ~="zhTW") then return end;

local StealthAlerterMyEnemiesTable = nil;
local StealthAlerterAllianceTable = {"R", "", "", "٪", "ҹ`", ""};
local StealthAlerterHordeTable = {"Ѫ`", "F", "ħ", "ţ^", "`", "粼"}; 

--
-- Search a table.
--
local function SearchTable(race, table)

   for _, v in pairs(table) do
      if (v == race) then 
         return true;
      end
   end

   return false;
end -- local function SearchTable()

-- 
-- Show the help.
--
local function ShowHelp()
   if StealthAlerterEnabled then
      DEFAULT_CHAT_FRAME:AddMessage("Ј"..StealthAlerterVersion.."_, ݔ\"/sal off\"P].", 0.0, 0.85, 0.0);
      if StealthAlerterShowFriendly == true then
         DEFAULT_CHAT_FRAME:AddMessage("Ј󾯕@ʾѷЄ, ݔ\"/sal nofriendly\"P]", 0.0, 0.85, 0.0);
      else
         DEFAULT_CHAT_FRAME:AddMessage("Ј󾯕[ѷЄ, ݔ\"/sal friendly\"P].", 0.0, 0.85, 0.0);
      end
      if StealthAlerterTerse == true then
         DEFAULT_CHAT_FRAME:AddMessage("Ј󾯕@ʾYӍݔ\"/sal noterse\" @ʾԔYӍ", 0.0, 0.85, 0.0);
      else
         DEFAULT_CHAT_FRAME:AddMessage("Ј󾯕@ʾԔYӍݔ\"/sal terse\"@ʾYӍ", 0.0, 0.85, 0.0);
      end
   else
      DEFAULT_CHAT_FRAME:AddMessage("Ј"..StealthAlerterVersion.." P]ݔ \"/sal on\" _", 0.0, 0.85, 0.0);
   end
end -- local function ShowHelp()

--
-- Handle slash commands.
--
function StealthAlerterCommand(command)
   local argc, argv = 0, {};
   gsub(command, "[^%s]+", function (word) argc=argc+1; argv[argc]=word; end);

   if (argc == 1) and (argv[1] == "help") then
      ShowHelp();
   elseif (argc == 1) and (argv[1] == "off") then
      DEFAULT_CHAT_FRAME:AddMessage("Ј"..StealthAlerterVersion.." P], ݔ \"/sal on\"_.", 0.0, 0.85, 0.0);
      StealthAlerterEnabled = false;
      StealthAlerterFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
   elseif (argc == 1) and (argv[1] == "on") then
      DEFAULT_CHAT_FRAME:AddMessage("Ј"..StealthAlerterVersion.." _, ݔ \"/sal off\"P].", 0.0, 0.85, 0.0);
      StealthAlerterEnabled = true;
      StealthAlerterFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
   elseif (argc == 1) and (argv[1] == "debug") then
      DEFAULT_CHAT_FRAME:AddMessage("Ј"..StealthAlerterVersion.."debug_, ݔ\"/sal undebug\"P].", 0.0, 0.85, 0.0);
      StealthAlerterDebug = true;
   elseif (argc == 1) and (argv[1] == "undebug") then
      DEFAULT_CHAT_FRAME:AddMessage("Ј"..StealthAlerterVersion.." debugP], ݔ\"/sal debug\" _.", 0.0, 0.85, 0.0);
      StealthAlerterDebug = false;
   elseif (argc == 1) and (argv[1] == "friendly") then
      DEFAULT_CHAT_FRAME:AddMessage("Ј󾯕@ʾѷЄ, ݔ\"/sal nofriendly\"P]", 0.0, 0.85, 0.0);
      StealthAlerterShowFriendly = true;
   elseif (argc == 1) and (argv[1] == "nofriendly") then
      DEFAULT_CHAT_FRAME:AddMessage("Ј󾯕[ѷЄ, ݔ\"/sal nofriendly\"_", 0.0, 0.85, 0.0);
      StealthAlerterShowFriendly = false;
   elseif (argc == 1) and (argv[1] == "terse") then
      DEFAULT_CHAT_FRAME:AddMessage("Ј󾯕@ʾYӍݔ\"/sal noterse\" @ʾԔYӍ", 0.0, 0.85, 0.0);
      StealthAlerterTerse = true;
   elseif (argc == 1) and (argv[1] == "noterse") then
      DEFAULT_CHAT_FRAME:AddMessage("Ј󾯕@ʾԔYӍݔ\"/sal terse\"@ʾYӍ", 0.0, 0.85, 0.0);
      StealthAlerterTerse = false;
   else
      ShowHelp();
   end
end -- function StealthAlerterCommand()

-- 
-- Do stuff when the AddOn is loaded.
--
function StealthAlerterOnLoad()
   StealthAlerterVersion = "0.99.12";   -- Version number.

   --
   -- Register a command handler.
   -- 
   SlashCmdList["STEALTHALERTERCMD"] = StealthAlerterCommand;
   SLASH_STEALTHALERTERCMD1 = "/sal";
   SLASH_STEALTHALERTERCMD2 = "/stealthalerter";
   
   if StealthAlerterEnabled == nil then
      StealthAlerterEnabled = true;
   end

   if StealthAlerterDebug == nil then
      StealthAlerterDebug = false;
   end

   if StealthAlerterShowFriendly == nil then
      StealthAlerterShowFriendly = true;
   end

   if StealthAlerterTerse == nil then
      StealthAlerterTerse = false;
   end

   --
   -- Get our race.
   --
   -- myFileName is not used.
   --
   local myRace, myFileName = UnitRace("player");

   -- 
   -- Set our enemies.
   --
   if SearchTable(myRace, StealthAlerterAllianceTable) then
      StealthAlerterMyEnemiesTable = StealthAlerterHordeTable;
   elseif SearchTable(myRace, StealthAlerterHordeTable) then
      StealthAlerterMyEnemiesTable = StealthAlerterAllianceTable;
   end

   StealthAlerterFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

   return;
end -- function StealthAlerterOnLoad()

-- 
-- Handle the events we've registered, print messages and do stuff.
--
function StealthAlerterOnEvent(event, ...)
   local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, mysteryArgument, destGUID, destName, destFlags, anotherMysteryArgument, spellId, SpellName = select(1, ...)

   if StealthAlerterEnabled == false then
      return;
   end

   --
   -- Look for interesting SPELL_CAST_SUCCESS events.
   --
   if event == "COMBAT_LOG_EVENT_UNFILTERED" and type == "SPELL_CAST_SUCCESS" then
      --
      -- Enable for verbose logging.  Probably a bad idea.
      --
      -- DEFAULT_CHAT_FRAME:AddMessage(""..spellId.." "..spellName.." " ..sourceName.. ".", 0.41, 0.8, 0.94);

      --
      -- Detect Rogues casting Vanish.
      --
      if spellId == 1856 then 
         local class, classFilename, race, raceFilename, sex = GetPlayerInfoByGUID(sourceGUID);
	 if race ~= nil and SearchTable(race, StealthAlerterMyEnemiesTable) then
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩʧ.", 1.0, 0.25, 0.25);
            else
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩʧ (3 ).", 1.0, 0.25, 0.25);
	    end
	 elseif race ~= nil and StealthAlerterShowFriendly then
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩʧ.", 0.41, 0.8, 0.94);
            else
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩʧ (3 ).", 0.41, 0.8, 0.94);
	    end
	 end
      --
      -- Detect Rogues casting Stealth.
      --
      elseif spellId == 1784 then 
         local class, classFilename, race, raceFilename, sex = GetPlayerInfoByGUID(sourceGUID);
	 if race ~= nil and SearchTable(race, StealthAlerterMyEnemiesTable) then 
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩʧ.", 1.0, 0.25, 0.25);
	    else
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩʧ.", 1.0, 0.25, 0.25);
            end
	 elseif race ~= nil and StealthAlerterShowFriendly then
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩʧ.", 0.41, 0.8, 0.94);
	    else
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩʧ.", 0.41, 0.8, 0.94);
	    end
	 end
      --
      -- Detect Druids casting Prowl.
      --
      elseif spellId == 5215 then
         local class, classFilename, race, raceFilename, sex = GetPlayerInfoByGUID(sourceGUID);
	 if race ~= nil and SearchTable(race, StealthAlerterMyEnemiesTable) then 
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩŝ.", 1.0, 0.25, 0.25);
            else
	       DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩŝ (ٶȜp 30%).", 1.0, 0.25, 0.25);
	    end
	 elseif race ~= nil and StealthAlerterShowFriendly then
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩŝ.", 0.41, 0.8, 0.94);
	    else
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩŝ (ٶȜp 30%).", 0.41, 0.8, 0.94);
	    end
	 end
      --
      -- Detect Night Elves casting Shadowmeld.
      --
      elseif spellId == 58984 then
         local class, classFilename, race, raceFilename, sex = GetPlayerInfoByGUID(sourceGUID);
	 if race ~= nil and SearchTable(race, StealthAlerterMyEnemiesTable) then 
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩӰ.", 1.0, 0.25, 0.25);
            else
	       DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩӰ.", 1.0, 0.25, 0.25);
	    end
	 elseif race ~= nil and StealthAlerterShowFriendly then
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩӰ.", 0.41, 0.8, 0.94);
            else
	       DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩӰ.", 0.41, 0.8, 0.94);
	    end
	 end
      --
      -- Detect Hunters casting Camouflage.
      --
      elseif spellId == 51753 then
         local class, classFilename, race, raceFilename, sex = GetPlayerInfoByGUID(sourceGUID);
	 if race ~= nil and SearchTable(race, StealthAlerterMyEnemiesTable) then 
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩłb.", 1.0, 0.25, 0.25);
            else
	       DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩłb (60 ).", 1.0, 0.25, 0.25);
	    end
	 elseif race ~= nil and StealthAlerterShowFriendly then
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩłb.", 0.41, 0.8, 0.94);
            else
	       DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩłb (60 ).", 0.41, 0.8, 0.94);
	    end
	 end
      --
      -- Detect Mages casting Invisibility.
      --
      elseif spellId == 66 then
         local class, classFilename, race, raceFilename, sex = GetPlayerInfoByGUID(sourceGUID);
	 if race ~= nil and SearchTable(race, StealthAlerterMyEnemiesTable) then 
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩ[.", 1.0, 0.25, 0.25);
            else
	       DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩ[ (20 ).", 1.0, 0.25, 0.25);
	    end
	 elseif race ~= nil and StealthAlerterShowFriendly then
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ʩ[.", 0.41, 0.8, 0.94);
            else
	       DEFAULT_CHAT_FRAME:AddMessage(""..sourceName.." ("..race..") ʩ[ (20 ).", 0.41, 0.8, 0.94);
	    end
	 end
      --
      -- Detect Invisibility potions.
      --
      elseif spellId == 3680 then
         local class, classFilename, race, raceFilename, sex = GetPlayerInfoByGUID(sourceGUID);
	 if race ~= nil and SearchTable(race, StealthAlerterMyEnemiesTable) then 
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName .. " ʹôμ[ˎ.", 1.0, 0.25, 0.25);
	    else
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName .. " ("..race..") ʹôμ[ˎ (15 ).", 1.0, 0.25, 0.25);
	    end
	 elseif race ~= nil and StealthAlerterShowFriendly then
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName .. " ʹôμ[ˎ.", 0.41, 0.8, 0.94);
            else
	       DEFAULT_CHAT_FRAME:AddMessage(""..sourceName .. " ("..race..") ʹôμ[ˎ (15 )", 0.41, 0.8, 0.94);
	    end
	 end
      elseif spellId == 11392 then
         local class, classFilename, race, raceFilename, sex = GetPlayerInfoByGUID(sourceGUID);
	 if race ~= nil and SearchTable(race, StealthAlerterMyEnemiesTable) then 
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName .. " ʹ[ˎ", 1.0, 0.25, 0.25); 
	    else
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName .. " ("..race..") ʹ[ˎ (18 ).", 1.0, 0.25, 0.25);
	    end
	 elseif race ~= nil and StealthAlerterShowFriendly then
            if StealthAlerterTerse then
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName .. " ʹ[ˎ.", 0.41, 0.8, 0.94);
	    else
               DEFAULT_CHAT_FRAME:AddMessage(""..sourceName .. " ("..race..") ʹ[ˎ (18 ).", 0.41, 0.8, 0.94);
	    end
	 end
      end
   end
end -- function StealthAlerterOnEvent()
